#include <cstdlib>
#include <iostream>
#include <string>
#include <fstream>

using namespace std;

char convertToASCII(char);
string strCopy(string,int,int);
bool stringCompare(string,string);  //This compares two strings to each other.  Note: returns 1 if the strings do not match and 0 if the strings do match.
string convertHexToString(int);
bool isStringAlphaNumeric(string);
int convertStringToHex(string s);
int compressData(string);
string stringInsert(string,string,int);

int xba(int);                 //Function that swaps the upper and lower bytes of a 2 byte value.
int func99EE(int,int);        //This function multiplies the first integer by 2^(2nd integer/2)
int func9A36(int,int);        //This function divides the first integer by 2^(2nd integer/2)
void func997B(void);          //This function is critical to the decompression, but there aren't good words to describe it at the moment.

unsigned short x=0;           //SNES X register
unsigned short y;             //SNES Y register
unsigned short a;             //SNES accumulator
bool carry;                   //SNES carry flag
unsigned short Var0E5F;       //This variable is critical to determining which bytes get copied during decompression
unsigned short Var0E61;       //This variable holds the previous two bytes drawn from the ROM to help determine VAR0E5F
unsigned short Var0E63;       //This variable helps determine Var0E5F
unsigned short Var0E65;       //This variable helps determine Var0E5F
unsigned short Var0E67;       //This variable determines the location of bytes to be copied from the already decompressed data.
ifstream infile;              //This is the file handle we will use to get data from the ROM.

int main(int argc, char *argv[])
{
    
    string fName2;              //This string will hold the name of the file that we will use to output data to.
    ofstream outfile;           //this is the file handle that we will use to output data to.
    fstream dataConfig;         //This it the file handle that we will use to output ROM location data to.
    int i;
    char decompressed[0xFFFFF]; //This will hold our decompressed data.
    unsigned int index=0;       //This index variable will be used to access and store data from the decompressed array.
    short x_readPos=0;          //This will store the value of x used for reading 8 byte sequences from the ROM.
    char temp;
    
    //The following variables are copied directly from Gemfire's decompression script.  The values are critical to successful decompression.
    short Var9728[]={0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x08,0x09,0x0A,0x0B,0x0C,0x0D,0x0E,0x0F,0x04,0x04,0x04,0x04,0x05,0x05,0x05,0x05,0x06,0x06,0x06,0x06,0x07,0x07,0x07,0x07,0x02,0x02,0x02,0x02,0x02,0x02,0x02,0x02,0x02,0x02,0x02,0x02,0x02,0x02,0x02,0x02,0x03,0x03,0x03,0x03,0x03,0x03,0x03,0x03,0x03,0x03,0x03,0x03,0x03,0x03,0x03,0x03};
    short Var9768[]={0x1A,0x18,0x14,0x14,0x10,0x10,0x10,0x10,0x0C,0x0C,0x0C,0x0C,0x0C,0x0C,0x0C,0x0C,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04};
    short Var97A7[]={0x04,0x04,0x08,0x08,0x0C,0x0C,0x0C,0x0C};
    short Var97AF[]={0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x02,0x02,0x02,0x02,0x02,0x02,0x02,0x02,0x03,0x03,0x03,0x03,0x03,0x03,0x03,0x03,0x04,0x04,0x04,0x04,0x05,0x05,0x05,0x05,0x06,0x06,0x06,0x06,0x07,0x07,0x07,0x07,0x08,0x08,0x09,0x09,0x0A,0x0A,0x0B,0x0B,0x0C,0x0C,0x0D,0x0D,0x0E,0x0E,0x0F,0x0F,0x10,0x10,0x11,0x11,0x12,0x12,0x13,0x13,0x14,0x14,0x15,0x15,0x16,0x16,0x17,0x17,0x18,0x18,0x19,0x19,0x1A,0x1A,0x1B,0x1B,0x1C,0x1C,0x1D,0x1D,0x1E,0x1E,0x1F,0x1F,0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27,0x28,0x29,0x2A,0x2B,0x2C,0x2D,0x2E,0x2F,0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37,0x38,0x39,0x3A,0x3B,0x3C,0x3D,0x3E,0x3F,0x40,0x41,0x42,0x43,0x44,0x45,0x46,0x47,0x48,0x49,0x4A,0x4B,0x4C,0x4D,0x4E,0x4F,0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,0x58,0x59,0x5A,0x5B,0x5C,0x5D,0x5E,0x5F,0x60,0x61,0x62,0x63,0x64,0x65,0x66,0x67,0x68,0x69,0x6A,0x6B,0x6C,0x6D,0x6E,0x6F,0x70,0x71,0x72,0x73,0x74,0x75,0x76,0x77,0x78,0x79,0x7A,0x7B,0x7C,0x7D,0x7E,0x7F};
    short Var986F[]={0x0E,0x0E,0x10,0x12,0x12,0x12,0x14,0x14,0x14,0x14,0x14,0x14};
    short Var9878[]={0,0,0,0x0A,0x08,0x06,0x04,0x02};
    short Var987D[]={0,0,0,0x16,0x18,0x1A,0x1C,0x1E};
    unsigned char readControl=0; //This variable is used to determine whether we read a byte directly from ROM of copy data from the decompressed array
    unsigned int startPoint=0;   //This is the starting position in the ROM.  We get the opportunity to change it later.
    bool LoROM=true;             //Whether the ROM is LoROM(true) or HiROM(false).  Does not currently affect anything.
    bool header=false;           //Whether the ROM has a header(true) or does not (false).  Does not currently affect anything.
    string fName1;               //This string will hold the name of the file to be entered by the user.
    string ROMHeaderName;        //This holds the name of the ROM as listed in the SNES header.  Does not currently affect anything.
    char * fileReader=new char[21];     //This is used to read a string of data directly from the ROM.  Does not currently affect anything.
    int previousInfileLocation=0;       //Holds the file location that was used previously as a start point for decompression.
    int endofFile;               //This holds the length of the file, the position that holds the end of file character.
    int tempFilePosition;        //This holds a file position
    int numBytes=1;              //This holds the number of bytes to be written to the decompressed array -1
    int numAlphaNumeric=0;       //This holds the number of alphanumeric bytes in the current decompressed sequence.
    int emptyMVNCount=0;         //This holds the number of large MVN statements in the current decompression (usually used for appending lots of 00 bytes at the end of the sequence)
    int selection1=0;             //This holds the user's selection when determining options.
    int selection2=0;             //This holds the user's selection when determining options.
    string startPointString;     //Holds user input data for decompressing a single sequence.
    string stringBuffer1;        //Used for string manipulation
    int tempInfilePosition;      //Used for making calculations involving file sizes
    
    cout<<"Welcome to the Koei SNES graphics decompressor!"<<endl;
    cout<<"Make sure the ROM is in the same folder as this program."<<endl;
    cout<<"Output files will be generated in this folder as well."<<endl;
    cout<<"Enter 1 to decompress file data, or 2 if you would like to compress it."<<endl;
    cin>>selection1;
    cin.ignore(256,'\n');
    if(selection1>2 || selection1<1)
    {
         cout<<"Invalid selection.  Press Enter to quit."<<endl;
         cin.get();
         return 0;
    }
    if(selection1==2)
    {
         cout<<"Please enter the name of the file with data to compress."<<endl;
         getline(cin,fName1);
         if(compressData(fName1)) return 0;
         cout<<"Successful compression!  Press enter to quit."<<endl;
         cin.get();
         return 0;
    }
    cout<<"Please enter the name of the file to decompress."<<endl;
    getline(cin,fName1);         //User inputs the name of the file to be used.
    
    fName2=fName1+".kdf"; //Take the name of the file and add .kdf to it (Koei decompressed file!)
    infile.open((fName1).c_str(),ios::binary|ios::in);    //open the file.
    if(!infile.is_open())        //Check to see if the input file opened succesfully.
    {
         cout<<"Input file failed to open. Press enter to quit."<<endl;
         cin.get();
         return 0;
    }
    
    outfile.open((fName2).c_str(),ios::binary);           //open the file to hold decompressed data
    fName2=fName1+".dat";                                 //Take ROM name and add .dat to it.
    dataConfig.open((fName2).c_str(),ios::out);           //Open the file that will hold ROM and .kdf location data.
    
    dataConfig<<"This file holds the ROM position of decompressed tiles, and shows"<<endl;
    dataConfig<<"the corresponding offset in the .kdf file, as well as the number of bytes."<<endl;
    dataConfig<<"ROM\t\tKDF\t\tSize\t\tComp.Size"<<endl;
    
    if(!outfile.is_open() || !dataConfig.is_open())        //Check to see if the output file opened successfully
    {
         cout<<"Output file failed to open. Press enter to quit."<<endl;
         cin.get();
         return 0;
    }
    cout<<"Options:"<<endl;       //Offer the user some options on how they would like to decompress data.
    cout<<"  1:Decompress file for graphics"<<endl;
    cout<<"  2:Decompress file for text"<<endl;
    cout<<"  3:Decompress a single image or piece of text"<<endl;
    cout<<"  4:Decompress everything"<<endl;
    cout<<"Selection:";
    cin>>selection2;               //Get the user's selection
    cin.ignore(256,'\n');        //Ignore newline characters remaining in the input stream.
    if(selection2==0 || selection2>4)     //Make sure the user's selection is valid.
    {
         cout<<"Invalid selection. Press enter to quit."<<endl;
         cin.get();
         return 0;
    }     
    startPoint=0x00000;           //By default, set the start point for decompression to the beginning of the input file.
    if(selection2==3)
    {
         cout<<"Please enter the starting position of the image or text in the file."<<endl;
         cout<<"If hex, please prefix this position with \"0x\":";
         
         getline(cin,startPointString);        //Get user input for the start of the sequence to be decompressed.
         stringBuffer1=strCopy(startPointString,0,2);     //Gets the first 2 bytes of user input from the string
         if(!stringCompare(stringBuffer1,"0x"))           //Check to see if first 2 bytes are "0x", indicating a hex number
         {
              startPoint=convertStringToHex(startPointString);    //Converts a hex string to an integer value to be used as the start point.
         }
         else
         {
              startPoint=(int)atof(startPointString.c_str());     //converts the string to an integer to be used as a start point.
         }
    }
    infile.seekg(startPoint);        //Set our starting file position
    while(infile.is_open())
    {
        //Initialize the variables used for decompression below.
        previousInfileLocation=infile.tellg();          //Store the current start point for decompression here.
        Var0E5F=(infile.get())&0x00FF;                  //The first value of Var0E5F is read directly from the ROM
        Var0E5F=(infile.get())*0x100 + Var0E5F;
        Var0E61=Var0E5F;                                //Initial Var0E61 is also equal to the value read from ROM
        Var0E65=0x20;
        Var0E63=0x00;
        numBytes=1;
        x=0;
        x_readPos=0;
        index=0;
        numAlphaNumeric=0;
        emptyMVNCount=0;
         while(infile.good())
         {
              if(numBytes==0)
              {
                   break;
              }
              x=x_readPos;
              x--;
              if(x>0x80)                               //Data is read from the file in 8 byte sequences, we reset X to 7 after we subtract 1 from 00 to get FF
              {
                          x=0x0007;
                          readControl=infile.get();    //Each bit of readControl determines whether we read a byte directly from the ROM, or we copy data that has already been decompressed
                          if(!infile.good()) break;    //Check for the end of the file
              }
              do
              {
                   if(readControl>=0x80)               //if the highest bit of readControl is 1, we read a byte directly from the ROM and append it to the end of our decompressed data.
                   {
                        readControl*=2;                //Multiplying readControl by 2 shifts the bits left by 1, so that the highest big now controls whether we read directly or copy a sequence of bytes from the already decompressed data
                        decompressed[index]=infile.get();         //Read a byte directly from ROM, place it in the decompressed data.
                        if(isalpha(decompressed[index]) && (decompressed[index]!= decompressed[index-1])) numAlphaNumeric++;    //keeps track of whether the byte was text or not (useful for finding text)
                        if(!infile.good()) break;       //Check for the end of the file
                        index++;                        //increment the write location by 1.  This ensures we append data to the end of the current sequence.
                        x--;                            //Decrement X to keep track of where we are in the current 8 byte sequence of ROM decompression
                   }
                   if(x>0x80)                           //At the end of the 8 byte sequence, we pull a new value for readControl from the ROM, and reset x to 7.
                   {
                          x=0x0007;
                          readControl=infile.get();
                          if(!infile.good()) break;     //Check for end of file.
                   }
              }while(readControl>=0x80);                //Actual decompression begins when the highest bit of readControl is 0
              if(!infile.good()) break;                 //Check for end of file.
              readControl*=2;                           //Shift the bits left by 1 in readControl
              x_readPos=x;                              //Store the current value of x so that we can remember it after this sequence.
              a=Var0E5F;                                //Grab the value of Var0E5F used to do most of the decompression
              if(a<0x8000)
              {
                   a/=2;
                   a=xba(a);
                   y=a&0x00FF;
                   if(y==0)
                   {
                        a=xba(a);
                        a/=2;
                        a=a|0x0080;
                        if((a&0x00FF)==0x00FF)
                        {
                             numBytes=0;
                             break; //Stop this decompression, we have finished the current sequence.
                        }
                        else
                        {
                            emptyMVNCount++;
                            if(emptyMVNCount>10) break;        //Sequences that do not really hold compressed data are likely to repeatedly use big MVN block moves, which diminishes performance.
                            numBytes=a;
                            x=Var9768[y];
                            func997B();
                        }
                   }
                   else if(y>=8)
                   {
                        x=Var9728[y];
                        a=x;
                        numBytes=a;
                        x=Var9768[y];
                        func997B();
                   }
                   else
                   {
                        a=xba(a);
                        x=Var97A7[y];
                        a=func9A36(a,x);
                        numBytes=a;
                        x=Var9768[y];
                        func997B();
                   }
              }
              else
              {
                   numBytes=1;
              }
              a*=2;
              if((int)a>=0x6000)
              {
                   if(a>=0x8000)
                   {
                        carry=true;
                   }
                   else
                   {
                       carry=false;
                   }
                   a*=2;
                   for(i=0;i<3;i++)
                   {
                   if(a>0x8000)
                   {
                        a*=2;
                        if(carry) a++;
                        carry=true;
                   }
                   else
                   {
                        a*=2;
                        if(carry) a++;
                        carry=false;
                   }
                   }
                   a=a&0x0007;
                   y=a&0x00FF;
                   a=Var0E5F;
                   a=a&0x0FFF;
                   a=a|0x1000;
                   x=Var9878[y];
                   a=func9A36(a,x);
                   x=Var987D[y];
              }
              else
              {
                   a*=2;
                   a=xba(a);
                   y=a&0x00FF;
                   a=Var97AF[y];
                   y/=16;
                   x=Var986F[y];
              }
              Var0E67=a;
              func997B();
              if(Var0E67>=index)
              {
                   break; //This prevents reading out of bounds of the decompressed array, and also helps indicate whether the current start point for decompression is incorrect.
              }
              for(i=0;i<=numBytes;i++)  //This loop copies a defined number of bytes that have already been decompressed onto the end of our current decompressed data.
              {
                   decompressed[index]=decompressed[index-Var0E67-1];
                   if(isalpha(decompressed[index]) && (decompressed[index]!= decompressed[index-1])) numAlphaNumeric++;
                   if(!infile.good()) break;
                   index++;
              }
              if(index>=0xFFFFF)      //This prevents writing data outside the bounds of our array.
              {
                   cout<<"Max data sequence length reached. Skipping rest."<<endl;
                   break;
              }
         }
         if(emptyMVNCount<=10 && Var0E67<index)    //Check to see if our decompressed sequence is potentially valid
         {
             tempInfilePosition=infile.tellg();
             if(selection2==1 && (((index%64)==00)&& index>63))    //If searching for graphics, the decompressed sequence must be a multiple of 64 bytes.
             {
                  tempFilePosition=outfile.tellp();
                  for(i=0;i<index;i++)
                  {
                       outfile.put(decompressed[i]);
                  }
                  dataConfig<<convertHexToString(previousInfileLocation)<<'\t'<<convertHexToString(tempFilePosition)<<'\t'<<convertHexToString(i)<<'\t'<<convertHexToString(tempInfilePosition-previousInfileLocation)<<endl;
             }
             if(selection2==2 && (numAlphaNumeric>(index*0.6) && index>20))     //If searching for text, the decompressed sequence should be mostly alphanumeric characters.
             {
                  tempFilePosition=outfile.tellp();
                  for(i=0;i<index;i++)
                  {
                       outfile.put(decompressed[i]);
                  }
                  dataConfig<<convertHexToString(previousInfileLocation)<<'\t'<<convertHexToString(tempFilePosition)<<'\t'<<convertHexToString(i)<<'\t'<<convertHexToString(tempInfilePosition-previousInfileLocation)<<endl;
             }
             if(selection2==3 || selection2==4)     //If option 3 is selected, the decompressed sequence will be printed to the output file regardless.
             {
                  tempFilePosition=outfile.tellp();
                  for(i=0;i<index;i++)
                  {
                       outfile.put(decompressed[i]);
                  }
                  dataConfig<<convertHexToString(previousInfileLocation)<<'\t'<<convertHexToString(tempFilePosition)<<'\t'<<convertHexToString(i)<<'\t'<<convertHexToString(tempInfilePosition-previousInfileLocation)<<endl;
                  if(selection2==3) break;          //The decompression is stopped after a single sequence in the case of option 3.
             }
         }
         if(selection2==3)
         {
              cout<<"Valid decompression sequence not found."<<endl;
              cout<<"Press Enter to quit."<<endl;
              cin.get();
              return 0;
         }
         previousInfileLocation++;      //Move our starting point forward one byte: We will try each byte in the ROM as a startpoint for decompression.
         if(!infile.good())       //Check to see if we have reached the end of file.
         {
              endofFile=infile.tellg();   //Get the position of the end of the file.
              if(previousInfileLocation>(endofFile-4))       //If we are four bytes or fewer from the end of the file, stop decompression.
              {
              cout<<"End of file reached."<<endl;
              break;
              }
              else
              {
                  infile.seekg(previousInfileLocation);  //Set our new starting position
                  infile.clear();                      //Clear the file flags so that infile.good() will be true again.
              }
         }
         else
         {
              infile.seekg(previousInfileLocation);    //Set our new starting position.
         }
    }
    infile.close();     //Close the input file
    outfile.close();    //Close the output file
    dataConfig.close(); //Close the ROM and .kdf location data file.
    cout<<"Successful decompression!"<<endl;
    cout<<"Press enter to exit."<<endl;
    cin.get();         //Give the user the chance to see the text before exiting.
    return 0;          //Exit successfully!
}

char convertToASCII(char hex)
{
     if(hex<10)
     {
          hex+=48;
     }
     else
     {
          hex+=55;
     }
     return hex;
}

string convertHexToString(int i)
{
       
     string tempString="";
     char hex;
     hex=(i&0xF0000000)/0x10000000;
     hex=convertToASCII(hex);
     if(hex!=0) tempString+=hex;
     hex=(i&0x0F000000)/0x01000000;
     hex=convertToASCII(hex);
     if(hex!=0 || tempString!="") tempString+=hex;
     hex=(i&0x00F00000)/0x00100000;
     hex=convertToASCII(hex);
     if(hex!=0 || tempString!="") tempString+=hex;
     hex=(i&0x000F0000)/0x00010000;
     hex=convertToASCII(hex);
     if(hex!=0 || tempString!="") tempString+=hex;
     hex=(i&0x0000F000)/0x00001000;
     hex=convertToASCII(hex);
     if(hex!=0 || tempString!="") tempString+=hex;
     hex=(i&0x00000F00)/0x00000100;
     hex=convertToASCII(hex);
     if(hex!=0 || tempString!="") tempString+=hex;
     hex=(i&0x000000F0)/0x00000010;
     hex=convertToASCII(hex);
     if(hex!=0 || tempString!="") tempString+=hex;
     hex=i&0x00000000F;
     hex=convertToASCII(hex);
     tempString+=hex;

     return tempString;
}

string strCopy(string s,int nStart, int nLength)
{
     string newString(s,nStart,nLength);
     return newString;
     
}

bool stringCompare(string s1, string s2)
{
     int i;
     int l=s1.length();
     if(l!=s2.length())
     {
 //         cout<<"Error in String Comparison."<<endl;
          return 1;
     }
     else
     {
          for(i=0;i<l;i++)
          {
               if(s1[i]==s2[i])
               {
                    continue;
               }
               else
               {
                   return 1;
               }
          }
          return 0;
     }
}

int xba(int i)
{
    int lowerByte=i&0x00FF;
    int upperByte=i&0xFF00;
    upperByte/=256;
    lowerByte*=256;
    upperByte+=lowerByte;
    return upperByte;
}

int func99EE(int a,int modifier)
{ //this function appears to simply take a, and multiply it by 2^(modifier/2).  They only start using xba to reduce the number of ASLs needed.
     int i;
     for(i=0;i<modifier;i+=2)
     {
          a*=2;
     }
     return a;
}

int func9A36(int a,int modifier)
{ //this function appears to simply take a, and divide it by 2^(modifier/2).  They only start using xba to save on LSRs, ROLs.
    int i;
     for(i=0;i<modifier;i+=2)
     {
          a/=2;
     }
     return a;
}

void func997B()
{
    int Var970E[]={0x0000,0x0001,0x0003,0x0007,0x000F,0x001F,0x003F,0x007F,0x00FF,0x01FF,0x03FF,0x07FF,0x0FFF,0x1FFF,0x3FFF,0x7FFF,0xFFFF};
    char * reader=new char[1];
     
    Var0E65=x&0x00FF;
    a=Var0E5F;
    a=func99EE(a,Var0E65);
    Var0E5F=a;
    x=Var0E63&0x00FF;
    if(Var0E63<Var0E65)
    {    
        Var0E65-=Var0E63;
        a=Var0E61;
        a=a&Var970E[x/2];
        a=func99EE(a,Var0E65);
        Var0E5F=Var0E5F|a;
        Var0E61=(infile.get())&0x00FF;
        Var0E61+=(infile.get())*0x100;
        x=0x0020;
        a=x;
    }
    Var0E63=x-Var0E65;
    a=Var0E61;
    a=func9A36(a,Var0E63);
    x=Var0E65;
    a=a&Var970E[x/2];
    a=Var0E5F|a;
    Var0E5F=a; 
}

bool isStringAlphaNumeric(string s)
{
     int i;
     for(i=0;i<s.length();i++)
     {
          if(s[i]<0x30 || s[i]>0x7A)
          {
               return 0;
          }
     }
     return 1;
}

int convertStringToHex(string s)
{
    int result=0; //this will be the value that is returned 
    int length=s.length();
    int i;
    int offsetBase=1;
    char temp;
    
    for(i=1;i<(length-1);i++)
    {
         temp=s[length-i];
         if(temp>=48 && temp<58)
         {
              temp-=48;
         }
         else
         {
              temp-=55;
         }
         result=result+temp*offsetBase;
         offsetBase*=16;
    }
    return result;
    
}

int compressData(string fileName)
{
     ifstream sourceFile(fileName.c_str(),ios::binary);
     fileName+=".kcf";
     ofstream outfile;
     string decompressed;
     string compressed="";
     char buffer1;
     char buffer2;
     int counter=0;
     int i;
     int j;
     int k;
     int maxI=0;
     int bestJ=0;
     int startPoint=0;
     char currentReadControl=0;
     int currentReadControl_position=2;
     char currentReadControl_CycleNumber=-1;
     int currentCopyControl=0;
     int currentCopyControl_position=0;
     int currentCopyPosition=0;
     int temp_numByteControl=0;
     int temp_numBits=0;
     int numBitsUsed=0;
     int temp;
     int numBitsBackup=0;
     
     if(!sourceFile.is_open())
     {
          cout<<"Error opening source file! Press enter to quit."<<endl;
          cin.get();
          return 1;
     }
     outfile.open(fileName.c_str(),ios::binary);
     if(!outfile.is_open())
     {
          cout<<"Error opening output file. Press enter to quit."<<endl;
          cin.get();
          return 1;
     }
     while(sourceFile.good())
     {
          decompressed+=(char)sourceFile.get();
     }
     while(counter<(decompressed.length()-1))
     {
          maxI=0;
          bestJ=0;
          if(counter>0xFFF)
          {
               startPoint=counter-0xFFF;
          }
          else
          {
               startPoint=0;
          }
          for(j=(counter-1);j>=startPoint;j--)
          {
               i=1;
               buffer1=decompressed[counter];
               buffer2=decompressed[j];
               while((buffer1==buffer2) && (i<0x100) &&((i+counter)<decompressed.length()))
               {
                    if(i>maxI)
                    {
                         maxI=i;
                         bestJ=j;
                    }
                    buffer1=decompressed[counter+i];
                    buffer2=decompressed[j+i];
                    i++;
               }
          }
          //At this point, j holds the startpoint, and i holds the number of bytes to copy
          //At this point, maxI and bestJ will both hold nonzero values if a copy is present.
          if(numBitsBackup<16)
           {
                currentCopyControl_position=currentCopyPosition;
                currentCopyPosition=compressed.length();
                compressed+='\0';
                compressed+='\0';
                numBitsBackup+=16;
           }
          if(currentReadControl_CycleNumber<0)
           {
                compressed+='\0';
                currentReadControl_position=compressed.length()-1;
                currentReadControl_CycleNumber=7;
           }
          if(maxI>=2)
          {
               //Here we input bytes that will control Var0E5F, 0E61, 0E63, and 0E65
               //maxI holds the number of bytes to send.
               bestJ=counter-bestJ-1;
               //bestJ holds the difference between the source location and destination location of copy
               maxI--;
               if(maxI>=0x80)
               {
                    temp_numBits=13;
                    temp_numByteControl=maxI-0x80;
               }
               else if(maxI>0xF)
               {
                    if(maxI>0x3F)
                    {
                         temp_numBits=12;
                    }
                    else if(maxI>0x1F)
                    {
                         temp_numBits=10;
                    }
                    else
                    {
                         temp_numBits=8;
                    }
                    temp_numByteControl=maxI;
               }
               else if(maxI>=0x2)
               {
                    temp_numByteControl=0;
                    if(maxI>=8) //Var9728[x08 to x0F]
                    {
                         temp_numBits=6;
                         temp_numByteControl=maxI;
                    }
                    else if(maxI>=4) //Var9728[x10 to x1F]
                    {
                         temp_numBits=4;
                         temp_numByteControl=maxI;
                    }
                    else if(maxI>=2) //Var9728[x30 to x3F]
                    {
                         temp_numBits=2;           //110000 to 111111 Only the top two bits used. Form value x3
                         temp_numByteControl=maxI;
                    }
                    //Var9728[x20 to x2F] is reserved for 2 byte transfers, but less efficient to do it this way...
                    //Next we must compare bits from array index of Var9728 to bits involved in location determination
                    //We must do this to save space before writing the copy control to the file.  Array index is 6 bits.
               }
               else
               {
                    temp_numByteControl=0x0001;
                    temp_numBits=0;            //If we set this as zero...it's not going to add it unless we increase by 1 after.
               }
               temp_numBits++; //Increases the number of bits used by 1.  The decompression script doesn't acknowledge the first bit.
               //Here is code for establishing the number of bytes operation
               i=16-numBitsUsed;
               numBitsBackup-=temp_numBits;
               if(temp_numBits>=i)
               {
                    j=temp_numBits-i;
                    temp=temp_numByteControl;
                    for(k=0;k<j;k++)
                    {
                         temp/=2;
                    }
                    currentCopyControl=currentCopyControl|temp;
                    compressed[currentCopyControl_position]=(char)(currentCopyControl&0x00FF);
                    currentCopyControl=xba(currentCopyControl);
                    compressed[currentCopyControl_position+1]=(char)(currentCopyControl&0x00FF);
                    currentCopyControl=0x0000;
                    numBitsUsed=numBitsUsed+temp_numBits-16;
                    j=16-j;
                    temp=temp_numByteControl;
                    for(k=0;k<j;k++)
                    {
                         temp*=2;
                    }
                    currentCopyControl=(currentCopyControl|temp)&0xFFFF;
               }
               else
               {
                    j=i-temp_numBits;
                    temp=temp_numByteControl;
                    for(k=0;k<j;k++)
                    {
                         temp*=2;
                    }
                    currentCopyControl+=temp;
                    currentCopyControl=currentCopyControl&0xFFFF;
                    numBitsUsed+=temp_numBits;
               }
               
               if(numBitsBackup<16)     //Check to see if we have used all bits, assign space for newCopyControl
               {
                    currentCopyControl_position=currentCopyPosition;
                    currentCopyPosition=compressed.length();
                    compressed+='\0';
                    compressed+='\0';
                    numBitsBackup+=16;
               }
               //Now comes code for determining location
               if(bestJ<0x80) //Top bit should be zero, next two bits cannot both be 1.
               {             //these comparisons below are incorrect.  I must compare with actual locations and then convert it to the (approximate) array index for Var97AF
                    if(bestJ>=0x20)   //Location >=x20 gives array index > x60 which yields 10 bits.
                    {                //00//00- 0110 0000  //xBF(index) corresponds to x7F(location)
                         temp_numByteControl=bestJ+0x40;
                         temp_numBits=10;
                    }
                    else if(bestJ>0x7)   //Location 8 to x1F //0x30 to 0x5F       2 bytes/location
                    {                    //x5E(index) x1F(location).  x18 loc range, x30 index range
                         temp_numByteControl=bestJ+0x10;    //((bestJ-8)*2+0x30)/2;
                         temp_numBits=9;
                    }
                    else if(bestJ>0x3)  //Location from 4 to 7  //0x20 to 0x2F    4 bytes/location
                    {
                         temp_numByteControl=bestJ+0x4;     //((bestJ-4)*4+0x20)/4;
                         temp_numBits=8;
                    }
                    else                //Location from 0 to 3 //0x00 to 0x1F     8 bytes/location
                    {
                        temp_numByteControl=bestJ;
                        temp_numBits=7;
                    }
               }
               else
               {
                    j=0;
                    if(bestJ>=0x800)            //11100000000000
                    {
                         i=bestJ-0x800;
                         temp_numByteControl=i+0x3800; //or 0x7000?
                         temp_numBits=15;
                    }
                    else if(bestJ>=0x400)      //110**********
                    {
                         i=bestJ-0x400;
                         temp_numByteControl=i+0x1800;
                         temp_numBits=14;
                    }
                    else if(bestJ>=0x200)      //101*********
                    {
                         i=bestJ-0x200;
                         temp_numByteControl=i+0xA00;
                         temp_numBits=13;
                    }
                    else if(bestJ>=0x100)      //100********
                    {
                         i=bestJ-0x100;
                         temp_numByteControl=i+0x400;
                         temp_numBits=12;
                    }
                    else if(bestJ>=0x080)       //011*******
                    {
                         i=bestJ-0x080;
                         temp_numByteControl=i+0x180;
                         temp_numBits=11;
                    }
               }
               temp_numBits--; //The decompression algorithm skips glosses over the 1st bit of determining the number of bytes, but I account for it here.
               i=16-numBitsUsed;
               numBitsBackup-=temp_numBits;
               if(temp_numBits>=i)
               {
                    j=temp_numBits-i;
                    temp=temp_numByteControl;
                    for(k=0;k<j;k++)
                    {
                         temp/=2;
                    }
                    currentCopyControl+=temp;
                    compressed[currentCopyControl_position]=(char)(currentCopyControl&0x00FF);
                    currentCopyControl=xba(currentCopyControl);
                    compressed[currentCopyControl_position+1]=(char)(currentCopyControl&0x00FF);
                    currentCopyControl=0x0000;
                    numBitsUsed=numBitsUsed+temp_numBits-16;
                    j=0x10-j;
                    temp=temp_numByteControl;
                    for(k=0;k<j;k++)
                    {
                         temp*=2;
                    }
                    currentCopyControl=(currentCopyControl|temp)&0xFFFF;
               }
               else
               {
                    j=i-temp_numBits;
                    temp=temp_numByteControl;
                    for(k=0;k<j;k++)
                    {
                         temp*=2;
                    }
                    currentCopyControl=(currentCopyControl|temp)&0xFFFF;
                    numBitsUsed+=temp_numBits;
               }
               counter+=(maxI+1); //increment the counter by the number of bytes copied.
               if(counter>=decompressed.length())
               {
                  break;
               }
          }
          else
          {
               //Here we copy the byte and update the readControl variable on file.
               compressed+=decompressed[counter];
               counter++;
               j=1;
               for(i=0;i<currentReadControl_CycleNumber;i++)
               {
                    j*=2;
               }
               currentReadControl+=j;
               
          }
          currentReadControl_CycleNumber--;
          if(currentReadControl_CycleNumber<0)
           {
                compressed[currentReadControl_position]=currentReadControl;
                currentReadControl=0;
           }
     }
     //Here we must write the end command to the current copyControl and readControl
      if(numBitsBackup<16)     //Check to see if we have used all bits, assign space for newCopyControl
      {
           currentCopyControl_position=currentCopyPosition;
           currentCopyPosition=compressed.length();
           compressed+='\0';
           compressed+='\0';
           numBitsBackup+=16;
      }
     temp_numByteControl=0x7F;
     temp_numBits=14;
     i=0x10-numBitsUsed;
       if(temp_numBits>=i)
       {
            j=temp_numBits-i;
            temp=temp_numByteControl;
            for(k=0;k<j;k++)
            {
                 temp/=2;
            }
            currentCopyControl+=temp;
            compressed[currentCopyControl_position]=(char)(currentCopyControl&0x00FF);
            currentCopyControl=xba(currentCopyControl);
            compressed[currentCopyControl_position+1]=(char)(currentCopyControl&0x00FF);
            currentCopyControl=0x0000;
            numBitsUsed=numBitsUsed+temp_numBits-16;
            j=0x10-j;
            temp=temp_numByteControl;
            for(k=0;k<j;k++)
            {
                 temp*=2;
            }
            currentCopyControl=(currentCopyControl|temp)&0xFFFF;
       }
       else
       {
            j=i-temp_numBits;
            temp=temp_numByteControl;
            for(k=0;k<j;k++)
            {
                 temp*=2;
            }
            currentCopyControl+=temp;
            currentCopyControl=currentCopyControl&0xFFFF;
            numBitsUsed+=temp_numBits;
       }
       if(currentCopyControl)
       {
       compressed[currentCopyPosition]=(char)(currentCopyControl&0x00FF);
       currentCopyControl=xba(currentCopyControl);
       compressed[currentCopyPosition+1]=(char)(currentCopyControl&0x00FF);
       }
       if(currentReadControl_CycleNumber>=0)
       {
            compressed[currentReadControl_position]=currentReadControl;
       }
       else
       {
            compressed+=currentReadControl;
       }
       for(i=0;i<compressed.length();i++)
       {
            outfile<<compressed[i];
       }
       return 0;
}
